From 8693392e58529cf662bd6ca3bf76f34be8c12f28 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 12 2020 16:57:07 +0000
Subject: [PATCH 1704/2232] Merge pull request #569 from dtolnay/typename


Fix omitted typenames incompatible with Visual C++ 2015
---

diff --git a/include/cxx.h b/include/cxx.h
index e3ef0be..8a91f26 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -783,7 +783,7 @@ Vec<T>::iterator::operator->() const noexcept {
 
 template <typename T>
 typename Vec<T>::iterator::reference Vec<T>::iterator::operator[](
-    Vec<T>::iterator::difference_type n) const noexcept {
+    typename Vec<T>::iterator::difference_type n) const noexcept {
   auto pos = static_cast<char *>(this->pos) + this->stride * n;
   return *static_cast<T *>(pos);
 }
@@ -815,22 +815,22 @@ typename Vec<T>::iterator Vec<T>::iterator::operator--(int) noexcept {
 }
 
 template <typename T>
-typename Vec<T>::iterator &
-Vec<T>::iterator::operator+=(Vec<T>::iterator::difference_type n) noexcept {
+typename Vec<T>::iterator &Vec<T>::iterator::operator+=(
+    typename Vec<T>::iterator::difference_type n) noexcept {
   this->pos = static_cast<char *>(this->pos) + this->stride * n;
   return *this;
 }
 
 template <typename T>
-typename Vec<T>::iterator &
-Vec<T>::iterator::operator-=(Vec<T>::iterator::difference_type n) noexcept {
+typename Vec<T>::iterator &Vec<T>::iterator::operator-=(
+    typename Vec<T>::iterator::difference_type n) noexcept {
   this->pos = static_cast<char *>(this->pos) - this->stride * n;
   return *this;
 }
 
 template <typename T>
 typename Vec<T>::iterator Vec<T>::iterator::operator+(
-    Vec<T>::iterator::difference_type n) const noexcept {
+    typename Vec<T>::iterator::difference_type n) const noexcept {
   auto ret = iterator(*this);
   ret.pos = static_cast<char *>(this->pos) + this->stride * n;
   return ret;
@@ -838,7 +838,7 @@ typename Vec<T>::iterator Vec<T>::iterator::operator+(
 
 template <typename T>
 typename Vec<T>::iterator Vec<T>::iterator::operator-(
-    Vec<T>::iterator::difference_type n) const noexcept {
+    typename Vec<T>::iterator::difference_type n) const noexcept {
   auto ret = iterator(*this);
   ret.pos = static_cast<char *>(this->pos) - this->stride * n;
   return ret;

